/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.ac.leeds.ccg.jianhuij.os;

import uk.ac.leeds.ccg.jianhuij.nn.*;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Jianhui Jin
 */
public class OSMain {

    public static void main(String[] args) {
        try {
            double[][][] xAndY = OSTrainingInputOutput.readTrainingInputOutput();
            NeuroNetwork nn = new NeuroNetwork(new int[]{30, 20, 10,5}, xAndY[0][0].length, 0.25, 1, xAndY[1][0].length);

            ObjectOutputStream objectOut = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream("C:/Users/Jianhui Jin/Work/OS/Development/SavedNN/Test/nn30_20_10_5_Itr5000")));
            objectOut.writeObject(nn);
            objectOut.close();

            ObjectInputStream objectIn = new ObjectInputStream(new BufferedInputStream(new FileInputStream("C:/Users/Jianhui Jin/Work/OS/Development/SavedNN/Test/nn30_20_10_5_Itr5000")));
            nn = (NeuroNetwork) objectIn.readObject();
            objectIn.close();


        SimulatedAnnealing sa = new SimulatedAnnealing(20, 0.5, 0.05, 50000, 1, nn, xAndY[0], xAndY[1]);
        System.out.println("1/3*random");
        sa.run();
        double[][] prediction = nn.runNN(xAndY[0]);
        for ( int i = 0; i < prediction.length; i ++ ) {
             System.out.println("Predicted: " + prediction[i][0] + ", Answer: " + xAndY[1][i][0]);
        }
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(OSMain.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(OSMain.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
